import Observable from "zen-observable";
import { Thread as ThreadType, Worker as WorkerType, WorkerEvent } from "../types/master";
export { FunctionThread, ModuleThread } from "../types/master";
export { spawn } from "./spawn";
export declare type Thread = ThreadType;
export declare const Thread: {
    errors<ThreadT extends ThreadType>(thread: ThreadT): Observable<Error>;
    events<ThreadT extends ThreadType>(thread: ThreadT): Observable<WorkerEvent>;
    terminate<ThreadT extends ThreadType>(thread: ThreadT): Promise<void>;
};
export declare type Worker = WorkerType;
export declare const Worker: typeof import("../types/master").WorkerImplementation;
