"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const symbols_1 = require("../symbols");
const implementation_1 = __importDefault(require("./implementation"));
var spawn_1 = require("./spawn");
exports.spawn = spawn_1.spawn;
function fail(message) {
    throw Error(message);
}
exports.Thread = {
    errors(thread) {
        return thread[symbols_1.$errors] || fail("Error observable not found. Make sure to pass a thread instance as returned by the spawn() promise.");
    },
    events(thread) {
        return thread[symbols_1.$events] || fail("Events observable not found. Make sure to pass a thread instance as returned by the spawn() promise.");
    },
    terminate(thread) {
        return thread[symbols_1.$terminate]();
    }
};
exports.Worker = implementation_1.default.selectWorkerImplementation();
