import Observable from "zen-observable";
import { FunctionParams, FunctionThread, ModuleThread, Worker as WorkerType } from "../types/master";
import { WorkerFunction, WorkerModule } from "../types/worker";
declare type ExposedToThreadType<Exposed extends WorkerFunction | WorkerModule<any>> = Exposed extends WorkerFunction ? FunctionThread<FunctionParams<Exposed>, StripAsync<ReturnType<Exposed>>> : Exposed extends WorkerModule<any> ? ModuleThread<Exposed> : never;
declare type StripAsync<Type> = Type extends Promise<infer PromiseBaseType> ? PromiseBaseType : Type extends Observable<infer ObservableBaseType> ? ObservableBaseType : Type;
export declare function spawn<Exposed extends WorkerFunction | WorkerModule<any>>(worker: WorkerType): Promise<ExposedToThreadType<Exposed>>;
export {};
