"use strict";
// tslint:disable no-shadowed-variable
const worker_threads_1 = require("worker_threads");
function assertMessagePort(port) {
    if (!port) {
        throw Error("Invariant violation: MessagePort to parent is not available.");
    }
    return port;
}
const postMessageToMaster = function postMessageToMaster(data, transferList) {
    assertMessagePort(worker_threads_1.parentPort).postMessage(data, transferList);
};
const subscribeToMasterMessages = function subscribeToMasterMessages(onMessage) {
    if (!worker_threads_1.parentPort) {
        throw Error("Invariant violation: MessagePort to parent is not available.");
    }
    const messageHandler = (message) => {
        onMessage(message);
    };
    const unsubscribe = () => {
        assertMessagePort(worker_threads_1.parentPort).off("message", messageHandler);
    };
    assertMessagePort(worker_threads_1.parentPort).on("message", messageHandler);
    return unsubscribe;
};
module.exports = {
    postMessageToMaster,
    subscribeToMasterMessages
};
